(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('apstorydnn-navigation-angular', ['exports', '@angular/common', '@angular/core', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['apstorydnn-navigation-angular'] = {}, global.ng.common, global.ng.core, global.rxjs));
}(this, (function (exports, i1, i0, rxjs) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var ApstorydnnNavigationService = /** @class */ (function () {
        function ApstorydnnNavigationService(componentFactory, location) {
            this.componentFactory = componentFactory;
            this.location = location;
            this.navSubject = new rxjs.Subject();
            this.paramSubject = new rxjs.Subject();
            this.navStack = [];
            this.params = {};
        }
        ApstorydnnNavigationService.prototype.setUrl = function (url) {
            location.href = url;
        };
        ApstorydnnNavigationService.prototype.getUrlParam = function (paramName) {
            var urlParameters = new URLSearchParams(this.location.path(false));
            return urlParameters.get(paramName);
        };
        ApstorydnnNavigationService.prototype.clearUrlParams = function () {
            this.location.replaceState('/', '');
        };
        ApstorydnnNavigationService.prototype.getNavigationEvent = function () {
            return this.navSubject.asObservable();
        };
        ApstorydnnNavigationService.prototype.getParameterEvent = function () {
            return this.paramSubject.asObservable();
        };
        ApstorydnnNavigationService.prototype.setComponent = function (type) {
            if (this.componentRef) {
                this.componentRef.destroy();
            }
            var factory = this.componentFactory.resolveComponentFactory(type);
            this.componentRef = this.componentHolder.createComponent(factory);
        };
        ApstorydnnNavigationService.prototype.setup = function (navHolder) {
            this.componentHolder = navHolder;
        };
        ApstorydnnNavigationService.prototype.setParam = function (key, value) {
            this.params[key] = value;
            this.paramSubject.next(key);
        };
        ApstorydnnNavigationService.prototype.getParam = function (key) {
            return this.params[key];
        };
        ApstorydnnNavigationService.prototype.push = function (page) {
            if (this.prevPage) {
                this.navStack.push(this.prevPage);
            }
            this.setComponent(page);
            this.prevPage = page;
            this.navSubject.next(this.componentRef);
        };
        ApstorydnnNavigationService.prototype.canPop = function () {
            return this.navStack.length > 0;
        };
        ApstorydnnNavigationService.prototype.popTo = function (screen) {
            while (typeof (screen) != typeof (this.prevPage)) {
                if (this.canPop()) {
                    this.prevPage = this.navStack.pop();
                }
            }
            this.setComponent(this.prevPage);
            this.navSubject.next(this.componentRef);
        };
        ApstorydnnNavigationService.prototype.popBack = function (nr) {
            for (var i = 0; i < nr; i++) {
                if (this.canPop()) {
                    this.prevPage = this.navStack.pop();
                }
            }
            this.setComponent(this.prevPage);
            this.navSubject.next(this.componentRef);
        };
        ApstorydnnNavigationService.prototype.pop = function () {
            if (this.canPop()) {
                this.prevPage = this.navStack.pop();
                this.setComponent(this.prevPage);
                this.navSubject.next(this.componentRef);
            }
        };
        return ApstorydnnNavigationService;
    }());
    /** @nocollapse */ ApstorydnnNavigationService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function ApstorydnnNavigationService_Factory() { return new ApstorydnnNavigationService(i0__namespace.ɵɵinject(i0__namespace.ComponentFactoryResolver), i0__namespace.ɵɵinject(i1__namespace.Location)); }, token: ApstorydnnNavigationService, providedIn: "root" });
    ApstorydnnNavigationService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ApstorydnnNavigationService.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver },
        { type: i1.Location }
    ]; };

    /*
     * Public API Surface of apstorydnn-navigation
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ApstorydnnNavigationService = ApstorydnnNavigationService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=apstorydnn-navigation-angular.umd.js.map
